DeferredFileOutputStream (Tomcat API Documentation)
Keywords: org.apache.tomcat.util.http.fileupload.DeferredFileOutputStream class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tomcat.util.http.fileupload
Class DeferredFileOutputStream

    java.lang.Object
      java.io.OutputStream
          org.apache.tomcat.util.http.fileupload.ThresholdingOutputStream
              org.apache.tomcat.util.http.fileupload.DeferredFileOutputStream

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable

    public class DeferredFileOutputStream

extends ThresholdingOutputStream

An output stream which will retain data in memory until a specified threshold is reached, and only then commit it to disk. If the stream is closed before the threshold is reached, the data will not be written to disk at all.

Version:
  $Id: DeferredFileOutputStream.java 711597 2008-11-05 16:09:26Z markt $
Author:
  Martin Cooper

Constructor Summary
`DeferredFileOutputStream(int threshold, java.io.File outputFile)` Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point.

Method Summary
`byte[]` | `getData()` Returns the data for this output stream as an array of bytes, assuming that the data has been retained in memory.
`java.io.File` | `getFile()` Returns the data for this output stream as a `File`, assuming that the data was written to disk.
`protected java.io.OutputStream` | `getStream()` Returns the current output stream.
`boolean` | `isInMemory()` Determines whether or not the data for this output stream has been retained in memory.
`protected void` | `thresholdReached()` Switches the underlying output stream from a memory based stream to one that is backed by disk.

Methods inherited from class org.apache.tomcat.util.http.fileupload.ThresholdingOutputStream
`checkThreshold, close, flush, getByteCount, getThreshold, isThresholdExceeded, write, write, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DeferredFileOutputStream

    public DeferredFileOutputStream(int threshold,
                                    java.io.File outputFile)

  Constructs an instance of this class which will trigger an event at the specified threshold, and save data to a file beyond that point.

  Parameters:
    `threshold` - The number of bytes at which to trigger an event.
    `outputFile` - The file to which data is saved beyond the threshold.

Method Detail

### getStream

    protected java.io.OutputStream getStream()
                                      throws java.io.IOException

  Returns the current output stream. This may be memory based or disk based, depending on the current state with respect to the threshold.

  Specified by:
    `getStream` in class `ThresholdingOutputStream`
  Returns:
    The underlying output stream.
  Throws:
    `java.io.IOException` - if an error occurs.

### thresholdReached

    protected void thresholdReached()
                             throws java.io.IOException

  Switches the underlying output stream from a memory based stream to one that is backed by disk. This is the point at which we realise that too much data is being written to keep in memory, so we elect to switch to disk-based storage.

  Specified by:
    `thresholdReached` in class `ThresholdingOutputStream`
  Throws:
    `java.io.IOException` - if an error occurs.

### isInMemory

    public boolean isInMemory()

  Determines whether or not the data for this output stream has been retained in memory.

  Returns:
    `true` if the data is available in memory; `false` otherwise.

### getData

    public byte[] getData()

  Returns the data for this output stream as an array of bytes, assuming that the data has been retained in memory. If the data was written to disk, this method returns `null`.

  Returns:
    The data for this output stream, or `null` if no such data is available.

### getFile

    public java.io.File getFile()

  Returns the data for this output stream as a `File`, assuming that the data was written to disk. If the data was retained in memory, this method returns `null`.

  Returns:
    The file for this output stream, or `null` if no such file exists.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.